/**************************
	Flickr Sidebar
	By Neo101
	Version 1.0.0
**************************/

var firstRun = checkSettingsFile()
if(firstRun == true){
	var showAuthorize = true
} else {
	var showAuthorize = false
}

	
var apiKey = '4033ffbec57db08bb872ab14f56b081c'
var sharedSecret = '83f40335368ffd76'
var frob = ''
var userID = readSetting('userID')
var token = readSetting('token')
var userName = readSetting('userName')

var photosPerPage = readSetting('photosPerPage')
var photosLastDays = readSetting('photosLastDays')
var photoSize = readSetting('photoSize')
var photoLink = readSetting('photoLink')

var debugUpload = readSetting('debugUpload')
var showLoadingMessage = readSetting('showLoadingMessage')

var isAuthenticated = false

var photoType = 'your'

var searchKeyword = ''
var uploading = false
	
window.onload = function(){
	if(token == '' || userID == ''){
		showAuthentication()
	} else {
		isAuthenticated = true
		viewUserPhotos()
		showLinks()
		showUserInfo()
	}
}

	
function viewUserPhotos(){
	var url = returnViewUserPhotosURL(1)
	if(showLoadingMessage == '1'){
		document.getElementById( 'photos' ).insertAdjacentHTML('afterBegin', '<div class=loading>Loading...</div>')
	}
	loadXMLDoc(url, 'view', onResponseView)
}


function viewAllPhotos(){
	var url = returnViewAllPhotosURL(1)
	if(showLoadingMessage == '1'){
		document.getElementById( 'photos' ).insertAdjacentHTML('afterBegin', '<div class=loading>Loading...</div>')
	}
	loadXMLDoc(url, 'view', onResponseView)
}


function viewPhotosNextPrevious(url){
	if(showLoadingMessage == '1'){
		document.getElementById( 'photos' ).insertAdjacentHTML('afterBegin', '<div class=loading>Loading...</div>')
	}
	loadXMLDoc(url, 'view', onResponseView)
}

function searchPhotosNextPrevious(url){
	if(showLoadingMessage == '1'){
		document.getElementById( 'searchResults' ).insertAdjacentHTML('afterBegin', '<div class=loading>Loading...</div>')
	}
	loadXMLDoc(url, 'search', onResponseSearch)
}


function changePhotoType(type){
	photoType = type
	if(type == 'your'){
		viewUserPhotos()
	}
	else if(type == 'all'){
		viewAllPhotos()
	}
}


function setPhotoTitle(){
	if(photoType == 'your'){
		var title = 'Your Recent Photos'
		var elementIdBold = 'yourPhotos'
		var elementIdNormal = 'allPhotos'
	}
	else if(photoType == 'all'){
		var title = 'All Recent Photos'
		var elementIdBold = 'allPhotos'
		var elementIdNormal = 'yourPhotos'
	}
	document.getElementById('photoTitle').innerHTML = title
	document.getElementById(elementIdBold).style.fontWeight = 'bold'
	document.getElementById(elementIdNormal).style.fontWeight = 'normal'
}


function returnPhotoURL(page){
	if(photoType == 'your'){
		return returnViewUserPhotosURL(page)
	}
	else if(photoType == 'all'){
		return returnViewAllPhotosURL(page)
	}
}


function returnViewUserPhotosURL(page){
	var d = new Date()
	var timeStampNow = d.getTime() / 1000 //in seconds
	var timeStampPrevious = parseInt( timeStampNow - ( 60 * 60 * 24 * photosLastDays ) )
	var apiSignature = hex_md5( sharedSecret + 'api_key' + apiKey + 'auth_token' + token + 
									 'methodflickr.photos.recentlyUpdated' + 'min_date' + timeStampPrevious + 
										'page' + page + 'per_page' + photosPerPage)
	var url = 'http://api.flickr.com/services/rest/?method=flickr.photos.recentlyUpdated&api_key=' + apiKey + '&auth_token=' + token + 
						'&min_date=' + timeStampPrevious + '&per_page=' + photosPerPage + '&page=' + page + '&api_sig=' + apiSignature
	return url
}


function returnViewAllPhotosURL(page){
	var url = 'http://api.flickr.com/services/rest/?method=flickr.photos.getRecent&api_key=' + apiKey + 
					'&page=' + page + '&per_page=' + photosPerPage
	return url
}


function login(){
	getFrob()
}


function getFrob(){
	var apiSignature = hex_md5( sharedSecret + 'api_key' + apiKey + 'methodflickr.auth.getFrob')
	var url = 'http://api.flickr.com/services/rest/?method=flickr.auth.getFrob&api_key=' + apiKey + '&api_sig=' + apiSignature
	
	loadXMLDoc(url, 'getFrob', onResponseGetFrob)
}


function returnSearchURL(keyword, page){
	keyword = keyword.replace(/&/g,'')
	var apiSignature = hex_md5( sharedSecret + 'api_key' + apiKey + 'methodflickr.photos.search' + 
								'page' + page + 'per_page' + photosPerPage + 'text' + keyword)
	var url = 'http://api.flickr.com/services/rest/?method=flickr.photos.search&api_key=' + apiKey + '&per_page=' + photosPerPage + 
					'&text=' + encodeURIComponent( keyword ) + '&page=' + page + '&api_sig=' + apiSignature
	
	return url
}


function showAuthentication(){
	document.getElementById('main').style.display = 'none'
	document.getElementById('authentication').style.display = ''
	
	getFrob()	
}


function search(){
	var keyword = document.getElementById('keyword').value
	if(keyword == ''){
		showError('Please enter a keyword')
		document.getElementById('searchResults').innerHTML = ''
		document.getElementById('searchNext').style.visibility = 'hidden'
		document.getElementById('searchPrevious').style.visibility = 'hidden'
		document.getElementById('searchNextTop').style.visibility = 'hidden'
		document.getElementById('searchPreviousTop').style.visibility = 'hidden'
		document.getElementById('numberOfResults').innerHTML = ''
		return
	}
	searchKeyword = keyword
	var url = returnSearchURL(keyword, '1')
	
	if(showLoadingMessage == '1'){
		document.getElementById( 'searchResults' ).insertAdjacentHTML('afterBegin', '<div class=loading>Loading...</div>')
	}
	loadXMLDoc(url, 'search', onResponseSearch)
}
	
	
function loadXMLDoc(url, type, stateChange, data){
	try{
		xmlhttp = new ActiveXObject("Microsoft.XMLHTTP")
	}
	catch(err){
		showError('Could not load ActiveX object')
	}
	xmlhttp.onreadystatechange = stateChange;
	xmlhttp.open("GET", url, true);
	xmlhttp.send(null);
}


function checkReadyState(obj){
	if(obj.readyState == 4){
		if(obj.status == 200 || obj.status == 201){
			return true;
		}
		else if(obj.status == 401 || obj.status == 403){
			showError('Could not login. Please check your account settings ' + obj.responseText)
		}
		else{
			showError(obj.status + ' ' + obj.responseText);
		}
	}
}


function getResponseXML(obj){
	var responseXML = xmlhttp.responseXML
		
	try{
		var state = responseXML.getElementsByTagName('rsp')[0].getAttribute('stat')
	}
	catch(err){
		var state = 'fail'
	}
	if(state == 'fail'){
		try{
			var code = responseXML.getElementsByTagName('err')[0].getAttribute('code')
			var msg = responseXML.getElementsByTagName('err')[0].getAttribute('msg')
			var message = 'Error ' + code + ': ' + msg
		}
		catch(err){
			var message = 'Error!'
			var code = ''
		}
		if(code == '98'){
			showAuthentication()
		}
		if(code == '108' && isAuthenticated == false){
			alert('Please authenticate the plugin before you press "continue"!')
			location.reload()
		}
		showError(message)
		return null
	}
	
	return responseXML
}


function onResponseGetFrob(){
	if( ! checkReadyState(xmlhttp) ){
		return
	}
	var responseXML = getResponseXML(xmlhttp)
	if( responseXML == null ){
		return
	}
	
	frob = responseXML.getElementsByTagName('frob')[0].text
	
	createLoginLink()
}


function createLoginLink(){
	var apiSignature = hex_md5( sharedSecret + 'api_key' + apiKey + 'frob' + frob + 'permswrite')
	var url = 'http://api.flickr.com/services/auth/?api_key=' + apiKey + '&perms=write&frob=' + frob + '&api_sig=' + apiSignature
	
	external.m2_callerName(SECURITY_ID, PLUGIN_NAME)
	document.getElementById('authLink').innerHTML = '1 <a href="' + url + '" target=_blank onclick="changeAuthLink()">Authenticate plugin</a>'
}


function changeAuthLink(){
	// document.getElementById('authLink').innerHTML = '<p>After you\'ve succesfully authenticated the plugin click "Continue".</p>'+
									// '<div class=next><a href="#" onclick="getToken()">Continue</a></div>'
}


function getToken(){
	var apiSignature = hex_md5( sharedSecret + 'api_key' + apiKey + 'frob' + frob + 'methodflickr.auth.getToken')
	var url = 'http://api.flickr.com/services/rest/?method=flickr.auth.getToken&api_key=' + apiKey + '&frob=' + frob + '&api_sig=' + apiSignature
	
	loadXMLDoc(url, 'getToken', onResponseGetToken)
}


function onResponseGetToken(){
	if( ! checkReadyState(xmlhttp) ){
		return
	}
	var responseXML = getResponseXML(xmlhttp)
	if( responseXML == null ){
		return
	}
	
	token = responseXML.getElementsByTagName('token')[0].text
	userID = responseXML.getElementsByTagName('user')[0].getAttribute('nsid')
	userName = responseXML.getElementsByTagName('user')[0].getAttribute('username')
	
	writeSetting('token', token)
	writeSetting('userID', userID)
	writeSetting('userName', userName)
	
	location.reload()
}



function onResponseSearch(){
	if( ! checkReadyState(xmlhttp) ){
		return
	}
	var responseXML = getResponseXML(xmlhttp)
	if( responseXML == null ){
		return
	}
	
	var response = ''
	
	var photos = new Array()
	
	items = responseXML.getElementsByTagName("photo"); 

	if(items && items.length != 0 ){
		for(var j=0; j < items.length; j++) {
			addPhoto(items[j], photos)
		}
	}
	else{
		response += '<b>No photo\'s found</b>'
	}
	
	response += writePhotoHtml( photos )

	document.getElementById('searchResults').innerHTML = response
	
	var photos = responseXML.getElementsByTagName("photos")[0]
	var page = parseInt( photos.getAttribute('page') )
	var pages = parseInt( photos.getAttribute('pages') )
	var total = parseInt( photos.getAttribute('total') )
	var nextPage =  page + 1
	var previousPage = page - 1
	
	var keyword = searchKeyword
	
	document.getElementById('numberOfResults').innerHTML = total + ' hits'
	
	if(pages > page){
		var urlNext = returnSearchURL(keyword, nextPage)
		document.getElementById('searchNext').onclick = function() { searchPhotosNextPrevious( urlNext ) }
		document.getElementById('searchNext').style.visibility = ''
		document.getElementById('searchNextTop').onclick = function() { searchPhotosNextPrevious( urlNext ) }
		document.getElementById('searchNextTop').style.visibility = ''
	} else {
		document.getElementById('searchNext').style.visibility = 'hidden'
		document.getElementById('searchNextTop').style.visibility = 'hidden'
	}
	
	if( previousPage > 0 ){
		var urlPrevious = returnSearchURL(keyword, previousPage)
		document.getElementById('searchPrevious').onclick = function() { searchPhotosNextPrevious( urlPrevious ) }
		document.getElementById('searchPrevious').style.visibility = ''
		document.getElementById('searchPreviousTop').onclick = function() { searchPhotosNextPrevious( urlPrevious ) }
		document.getElementById('searchPreviousTop').style.visibility = ''
	} else {
		document.getElementById('searchPrevious').style.visibility = 'hidden'
		document.getElementById('searchPreviousTop').style.visibility = 'hidden'
	}
		
}


function onResponseView(){
	if( ! checkReadyState(xmlhttp) ){
		return
	}
	var responseXML = getResponseXML(xmlhttp)
	if( responseXML == null ){
		return
	}
	
	var response = ''
	
	var photos = new Array()
	
	items = responseXML.getElementsByTagName("photo")

	if(items && items.length != 0 ){
		for(var j=0; j < items.length; j++) {
			addPhoto(items[j], photos)
		}
	}
	else{
		response += '<b>No photo\'s found</b>'
	}
	
	response += writePhotoHtml( photos )
	
	var photos = responseXML.getElementsByTagName("photos")[0]
	var page = parseInt( photos.getAttribute('page') )
	var pages = parseInt( photos.getAttribute('pages') )
	var nextPage =  page + 1
	var previousPage = page - 1

	if(pages > page){
		var urlNext = returnPhotoURL(nextPage)
		document.getElementById('photosNext').onclick = function() { viewPhotosNextPrevious(urlNext) }
		document.getElementById('photosNext').style.visibility = ''
		document.getElementById('photosNextTop').onclick = function() { viewPhotosNextPrevious(urlNext) }
		document.getElementById('photosNextTop').style.visibility = ''
	} else {
		document.getElementById('photosNext').style.visibility = 'hidden'
		document.getElementById('photosNextTop').style.visibility = 'hidden'
	}
	if( previousPage > 0 ){
		var urlPrevious = returnPhotoURL(previousPage)
		document.getElementById('photosPrevious').onclick = function() { viewPhotosNextPrevious(urlPrevious) }
		document.getElementById('photosPrevious').style.visibility = ''
		document.getElementById('photosPreviousTop').onclick = function() { viewPhotosNextPrevious(urlPrevious) }
		document.getElementById('photosPreviousTop').style.visibility = ''
	} else {
		document.getElementById('photosPrevious').style.visibility = 'hidden'
		document.getElementById('photosPreviousTop').style.visibility = 'hidden'
	}
	
	
	document.getElementById('photos').innerHTML = response
	setPhotoTitle()
	
}


function writePhotoHtml( array ){
	var response = ''
	for(var i=0; i<array.length ; i++){
		response += '<a href="' + array[i].link + '" target=_blank>'+
						'<img src="' + array[i].imageSource + '" alt="' + array[i].message + '">' + 
					'</a><br><br>'
	}
	
	return response
}


function addPhoto( item , array){
	var title = item.getAttribute('title')
	var id = item.getAttribute('id')
	var secret = item.getAttribute('secret')
	var server = item.getAttribute('server')
	var owner = item.getAttribute('owner')
	var ispublic = item.getAttribute('ispublic')
	
	if(id == ''){
		return
	}
	
	//var link = 'http://www.flickr.com/photos/' + owner + '/' + id
	var link = photoLink.replace(/\$id\$/g, id).replace(/\$owner\$/g, owner)
	var imageSource = 'http://static.flickr.com/' + server + '/' + id + '_' + secret + '_'+photoSize+'.jpg'
	var message = 'Title: ' + title + '\n'
	message += ( ispublic == '0' ) ? 'Private photo' : 'Public photo'
	
	
	array.push( {'message':message,
				'link':link,
				'imageSource':imageSource
				} )
}


function checkform(form){
	if(form.photo.value == ''){
		showError('Please select a photo first!')
		return false
	}


	var description = form.description.value
	var tags = form.tags.value
	var title = form.title.value

	var apiSignature = hex_md5( sharedSecret + 'api_key' + apiKey + 'auth_token' + token + 'description' + description +
									'tags' + tags + 'title' + title)

	var url =  'http://api.flickr.com/services/upload/'
	
	form.api_key.value = apiKey
	form.auth_token.value = token
	
	form.action = url
	document.getElementById('uploading').style.display = ''
	uploading = true
	
	form.api_sig.value = apiSignature
	
	if(debugUpload == '1'){
		form.target = '_blank'
	}
}


function showPreview(element){
	var source = element.value
	var image = document.getElementById('preview')
	if(source == ''){
		image.style.display = 'none'
		return
	}
	image.onerror = function(){
							showError('Make sure you\'ve selected a valid image!') 
							document.getElementById('preview').style.display = 'none'
						}
	image.style.display = ''
	image.onload = function(){
		//var image = document.getElementById('preview')
		while(image.height > 100){
			document.getElementById('preview').height -= 10
		}
		while(image.width > 100){
			document.getElementById('preview').width -= 10
		}
	}
	image.src = source
}


function showLinks(){
	if(userID == ''){
		return
	}
	var html = '| <a href="http://www.flickr.com/photos/' + userID + '" target=_blank title="Open Your Photos in a new tab">Your Photos</a><br>'
	//html += '<a href="http://www.flickr.com/people/' + userID + '" target=_blank>Your Contacts</a><br>'
	//html += '<a href="http://www.flickr.com/account/" target=_blank>Your Account</a><br>'
	
	document.getElementById('links').innerHTML += html
}


function showUserInfo(){
	if( userName == ''){
		return
	}
	document.getElementById('userInfo').innerHTML = 'Logged in as ' + userName + ' <a href="#" onclick="logout()" title="Clear account info for this plugin">(logout)</a>'
}


function logout(){
	writeSetting('userName', '')
	writeSetting('userID', '')
	writeSetting('token', '')
	
	location.reload()
}


function iframeStateChange(iframe){
	if(uploading){
		if(iframe.readyState == 'complete'){
			showError('Photo uploaded')
			viewUserPhotos()
			clearUploadForm()
			uploading = false
			document.getElementById('uploading').style.display = 'none'
			clickTab(1)
		}
	}
}


function clearUploadForm(){
	var form = document.getElementById('uploadForm')
	form.description.value = ''
	form.tags.value = ''
	form.title.value = ''
	form.photo.value = ''
}
